



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux内存管理--用户空间和内核空间【转】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux内存管理--用户空间和内核空间【转】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 11:33:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>本文转载自:<a href="http://blog.csdn.net/yusiguyuan/article/details/12045255" rel="external nofollow noreferrer">http://blog.csdn.net/yusiguyuan/article/details/12045255</a></strong></p>
<p><strong>关于虚拟内存有三点需要注意：</strong></p>
<ul><li><strong>4G的进程地址空间被人为的分为两个部分--用户空间与内核空间。用户空间从0到3G（0xc0000000）,内核空间占据3G到4G。用户进程通常情况下只能访问用户空间的虚拟地址，不能访问内核空间的虚拟地址。例外情况只有用户进程进行系统调用（代表用户进程在内核态执行）等时刻可以访问到内核空间。</strong></li>
<li><strong>用户空间对应进程，所以每当进程切换，用户空间就会跟着变化；而内核空间是由内核负责映射，它并不会跟着进程变化，是固定的。内核空间地址有自己对应的页表，用户进程各自有不同的页表。</strong></li>
<li><strong>每个进程的用户空间都是完全独立、互不相干的。<br /></strong></li></ul>
<h1><strong>一、4G地址空间解析图</strong></h1>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130926120346703" /></p>
<p><strong>上图展示了整个进程地址空间的分布，其中4G的地址空间分为两部分，在用户空间内，对应了内存分布的五个段：数据段、代码段、BSS段、堆、栈。在上篇文章中有详细的介绍。</strong></p>
<h1><strong>二、虚拟地址空间分配及其与物理内存对应图</strong></h1>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130926120338812" /></p>
<p>这个图示内核用户空间的划分，图中最重要的就是高端内存的映射<strong><br /></strong></p>
<p><strong>&nbsp;&nbsp; 其中kmalloc和vmalloc函数申请的空间对应着不同的区域，同时又不同的含义。</strong></p>
<h1><strong>三、物理内存分配图</strong></h1>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20130926120409500" /></p>
<p><strong>这张图中页解释了三者的不同关系，和上篇文章中的内容有相似之处。</strong></p>
<p><strong>伙伴算法：</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp; 一种物理内存分配和回收的方法，物理内存所有空闲页都记录在BUDDY链表中。首选，系统建立一个链表，链表中的每个元素代表一类大小的物理内存，分别为2的0次方、1次方、2次方，个页大小，对应4K、8K、16K的内存，没一类大小的内存又有一个链表，表示目前可以分配的物理内存。例如现在仅存需要分配8K的物理内存，系统首先从8K那个链表中查询有无可分配的内存，若有直接分配；否则查找16K大小的链表，若有，首先将16K一分为二，将其中一个分配给进程，另一个插入8K的链表中，若无，继续查找32K，若有，首先把32K一分为二，其中一个16K大小的内存插入16K链表中，然后另一个16K继续一分为二，将其中一个插入8K的链表中，另一个分配给进程........以此类推。当内存释放时，查看相邻内存有无空闲，若存在两个联系的8K的空闲内存，直接合并成一个16K的内存，插入16K链表中。（伙伴算法用于物理内存分配方案）</strong></p>
<p><strong>SLAB算法：</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp; 是一种对伙伴算的一种补充，对于用户进程的内存分配，伙伴算法已经够好了，但对于内核进程，还需要存在一类很小的数据（字节大小，比如进程描述符、虚拟内存描述符等），若每次给几个字节的数据分配一个4KB的页，实在太浪费，于是就有了SLBA算法，SLAB算法其实就是把一个页用力劈成一小块一小块，然后再分配。</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8okr259.html">mybatis源码分析：</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93jdjg8.html">html页面的CSS、DIV命名规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r4v2m8.html">svn&colon; E155004 is already locked 解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g4j409.html">Tp验证码&colon;&dollar;Verify &equals; new &bsol;Think&bsol;Verify&lpar;&rpar;&semi; &dollar;Verify-&amp;gt&semi;entry&lpar;n&rpar;&semi;【参数n&comma;页面有多个验证码时用】</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x36nm8.html">&amp;quot&semi;Mac OS X&amp;quot&semi;想要进行更改。键入管理员的名称和密码以允许执行此操作&lpar;&amp;quot&semi;Mac OS X&amp;quot&semi;想使用系统钥匙串&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e10dnx9.html">&period;net4&period;0下 解决asp&period;net中&amp;ldquo&semi;从客户端中检测到有潜在危险的Request&period;Form值&amp;rdquo&semi;的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1k5p59.html">POi写入大批量数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ekvn9.html">Hibernate逍遥游记-第1章-JDBC访问数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4l5xq.html">php 之 PDO数据访问抽象层&lpar;0513&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x222m8.html">把Go程序变小的办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kg1wz9.html">易爆物D305</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2nr0oq.html">flume安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy54d2q.html">Tapable&period;plugin is deprecated&period; Use new API on &grave;&period;hooks&grave; instead</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv274p19.html">File类&lowbar;深度遍历文件夹&lowbar;练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/96065y49.html">从QQ音乐开发，探讨如何利用腾讯云SDK在直播中加入视频动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pz4keq.html">交叉编译gdb和gdbserver</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjp0wr8.html">IE版本检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn7ln4q.html">python多态和鸭子类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql170ve9.html">MVC动态添加文本框&comma;后台使用FormCollection接收</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvenydx9.html">cocos2d-x 3&period;0 事件处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4p4lxeq.html">2018&sol;03&sol;16 echo、print&lowbar;r、print、var&lowbar;dump之间的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnd7ggq.html">&lbrack;转&rsqb;基于S2SH框架的项目&mdash;antlr-2&period;7&period;2&period;jar包冲突问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/963m1ky9.html">【Python】【亲测好用】安装第三方包报错：AttributeError&colon;&amp;&num;39&semi;module&amp;&num;39&semi; object has no attribute &amp;&num;39&semi;main&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/953p6ez8.html">第2章 2&period;n物理层--数据通信基础知识总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlo7kl9.html">windows dos命令大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkv5218.html">UIAlertview 添加图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppm14y9.html">自定义Metrics：让Prometheus监控你的应用程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vpzo5q.html">PAT 1087 All Roads Lead to Rome&lbrack;图论&rsqb;&lbrack;迪杰斯特拉&plus;dfs&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pmzyeq.html">Outlier Detection</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmnzve9.html">nodejs加WebSocket&comma;聊天工具</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
